justep.attachmentImage2 = function (){
	this.data = [];
	this.changeLog = {items:[],"operate":"","url":""};
};

justep.attachmentImage2.prototype.getValue = function(){
    var values = justep.xbl(this.ownerData).getValue(this.relation);
	try {
		this.data = values? JSON.parse(values): [];
	}
	catch (E) {
		/* 数据加载出错，忽略数据 */
		this.data = [];
	}
};

justep.attachmentImage2.prototype.setValue = function(data , rowid){
	var old = this.context;
	this.context = false;
	try{
	   var tempData = (JSON.stringify(data)!="[]"? JSON.stringify(data): "");
	   justep.xbl(this.ownerData).setValue(this.relation, tempData , rowid);
	}catch(e){
		throw e;
	}finally{
       this.context = old;
	}
};

justep.attachmentImage2.prototype.ownerChanged = function(){
	var value = justep.xbl(this.ownerData).getValue(this.relation);
	if(this.oldRelationData==value) return;
	this.loadData();
	this.oldRelationData = value;
};

justep.attachmentImage2.prototype.onWindowResize = function(){
	this.loadData();
};

justep.attachmentImage2.prototype.loadData = function(){
	var img = $('#'+this.imgID);
	var self = $('#'+this._id);
	this.getValue();
	if(this.data.length > 0){
		var imgWidth = self.get(0).offsetWidth;
		var imgHeight = self.get(0).offsetHeight;
		if (this.stretch) {
			img.css('width',imgWidth);
			img.css('height',imgHeight);
			img.attr("src", justep.doc.InnerUtils.getURLByFileID(this.rootPath, this.data[0].fileID));
		}else {
			var tempImage = new Image();  
			tempImage.onload = function() {
				/* tempImage用于获取高度和宽度 */
				var imgWidthValue = (typeof imgWidth) == "string"?parseInt(imgWidth.replace('px','')):imgWidth;
				var imgHeightValue = (typeof imgWidth) == "string"?parseInt(imgHeight.replace('px','')):imgHeight;
				var scaleH = tempImage.width / imgWidthValue;
				var scaleV = tempImage.height / imgHeightValue;
				var scale = 1;
				if (scaleH > scaleV) {
					scale = scaleH;
				}
				else {
					scale = scaleV;
				}
				img.css('width',(tempImage.width / scale));
				img.css('height',(tempImage.height / scale));
				img.attr('src',tempImage.src);
				self.css('background-color','white');
				tempImage = null;
			}
			tempImage.src = justep.doc.InnerUtils.getURLByFileID(this.rootPath, this.data[0].fileID);
		}
		self.parent().scrollLeft(0);
		self.parent().scrollTop(0);
		
	}else{
		img.attr("src",justep.Request.convertURL('/UI/system/images/doc/empty.gif', true));
		self.css('background-color','#E3EBF7');
	}
	img.width('100%');
	img.height('100%');
};

justep.attachmentImage2.prototype.init = function(){
	var define = justep.doc.InnerUtils.queryDefine(this.process, this.activity, this.keyId ,true);
    if(define){
		if(define.rootPath){
			this.rootPath = define.rootPath;
		}
		if(define.subPath){
			this.subPath = define.subPath;
		}
		if(define.limitSize){
			this.limitSize = define.limitSize;
		}
		if(define.access){
			this.access = define.access;
		}
    }
	/*var docServerInfo = justep.Doc2.getDocServerByDocPath(this.rootPath);
	if (docServerInfo == null || docServerInfo == "undefined"){
	   throw new Error('"获取文档服务器host失败！"');
	   return;
	}	
	this.host = window.location.protocol+"//"+docServerInfo.host+":"+docServerInfo.port;*/
	
	this.initUploader();
	this.initLightBox();
};

justep.attachmentImage2.prototype.initUploader = function(buttonName){
	var uiLayer = YAHOO.util.Dom.getRegion('btn_edit_'+this._id);
    var w = uiLayer.right - uiLayer.left;
    
    var h = uiLayer.bottom - uiLayer.top;
    w=w>0?w:16;
    h=h>0?h:20;
    
    if(this.runtime=="flash"){
    	var filter = new Array({description:"所有图片文件", extensions:"*.bmp;*.JPG;*.JPEG;*.JPE;*.JFIF;*.GIF;*.PNG;*.TIF;*.TIFF"}, 
			    {description:"JPEG(*.JPG;*.JPEG;*.JPE;*.JFIF)", extensions:"*.JPG;*.JPEG;*.JPE;*.JFIF"}, 
			    {description:"GIF(*.GIF)", extensions:"*.GIF"}, 
			    {description:"位图文件(*.BMP)", extensions:"*.BMP"}, 
			    {description:"PNG(*.PNG)", extensions:"*.PNG"}, 
			    {description:"TIF(*.TIF;*.TIFF)", extensions:"*.TIF;*.TIFF"});
		if(this.extensionFilter){
			var filter = this.transformExtensionFilter(this.extensionFilter);
		}
    	var ClickCallback = function(event){
    		var self = this;
    		if (justep.xbl(this.ownerData).getCount() < 1) {
    			alert(new justep.Message(justep.Message.JUSTEP232059).getMessage());
				return false;
			}
    		if (self.checkEvent("onEditClick")){
    			var eventData = {
    					'cancel' : false,
    					'source' : this
    			};
     		    self.callEvent("onEditClick", [eventData]);
     		   if (eventData.cancel)
     				return false;
    	    }
    	};
    	var selectedCallback = function(fileList,uploader){
    		var self = this;
    		if (justep.xbl(this.ownerData).getCount() < 1) {
    			alert(new justep.Message(justep.Message.JUSTEP232059).getMessage());
				return false;
			}
    		if (self.checkEvent("onFileSelected")){
    			var eventData = {
    					'cancel' : false,
    					'source' : this,
    					'fileList':fileList,
    					'uploader':uploader
    			};
     		   self.callEvent("onFileSelected", [eventData]);
     		   if(eventData.cancel){
     			  return false;
     		   }
    	    }
    	};
    	
    	var completedCallback = function(fileList,uploader){
    		var self = this;
    		if (self.checkEvent("onUploadCompleted")){
    			var eventData = {
    					'source' : this,
    					'fileList':fileList,
    					'uploader':uploader
    			};
     		   self.callEvent("onUploadCompleted", [eventData]);
    	    }
    	};
        this.uploader = justep.doc.InnerUtils.getUploader( this._id + "_uploaderDiv", this.subPath?this.rootPath+"/"+this.subPath:this.rootPath, this.limitSize, this.upload, ClickCallback, w, h, 1, filter, false, this,selectedCallback,completedCallback);
	}else if(this.runtime == "html4"){
		var filter = "bmp|JPG|JPEG|JPE|JFIF|GIF|PNG|TIF|TIFF";
		if(this.extensionFilter){
			var filter = this.transformExtensionFilter(this.extensionFilter);
		}
		if (justep.Browser.isInApp && justep.Browser.isIDevice) {
			var self = this;
			$("#" + self._id + "_uploaderDiv").bind(
					'click',
					function() {
						if (self.checkEvent("onEditClick")) {
							var eventData = {
								'cancel' : false,
								'source' : self
							};
							self.callEvent("onEditClick", [ eventData ]);
							if (eventData.cancel)
								return false;
						}
						var justepApp = justep.getJustepApp();
						
						
						var getUploadUrl = function() {
							var docUrl = justep.doc.InnerUtils.getdocServerAction(
									self.subPath?self.rootPath + "/" + self.subPath
											: self.rootPath,
									"/repository/file/cache/upload", true);
							if (docUrl.indexOf("uploadDoc.j") != -1
									&& docUrl.indexOf("#") == -1) {
								docUrl = window.location.protocol + "//"
										+ window.location.host + docUrl;
							}
							return docUrl;
						};
						var uploadCallback = function(response, fileName) {
							if (self.checkEvent("onUploadCompleted")) {
								var eventData = {
									'source' : self,
									'fileList' : fileList,
									'uploader' : uploader
								};
								self.callEvent("onUploadCompleted", [ eventData ]);
							}
							var file = $(response).find("file");
							var kind = $(file).attr("mediatype");
							var cacheName = $(file).attr("file-name");
							var size = $(file).attr("fileSize");
							self.upload.call(self,fileName, kind, size, cacheName);
						};
						justepApp.attachment.uploadAttachment(getUploadUrl,uploadCallback);
					});
		}else {
			var ClickCallback = function(event){
				var self = this;
				if (justep.xbl(this.ownerData).getCount() < 1) {
					alert(new justep.Message(justep.Message.JUSTEP232059).getMessage());
					return false;
				}
				if (self.checkEvent("onEditClick")){
					var eventData = {
							'cancel' : false,
							'source' : this
					};
		 		    self.callEvent("onEditClick", [eventData]);
		 		   if (eventData.cancel)
		 				return false;
			    }
			};
			var selectedCallback = function(fileList,uploader){
				var self = this;
				if (justep.xbl(this.ownerData).getCount() < 1) {
					alert(new justep.Message(justep.Message.JUSTEP232059).getMessage());
					return false;
				}
				if (self.checkEvent("onFileSelected")){
					var eventData = {
							'cancel' : false,
							'source' : this,
							'fileList':fileList,
							'uploader':uploader
					};
		 		   self.callEvent("onFileSelected", [eventData]);
		 		   if(eventData.cancel){
		 			  return false;
		 		   }
			    }
			};
			
			var completedCallback = function(docName,uploader,response){
				var self = this;
				if (self.checkEvent("onUploadCompleted")){
					var eventData = {
							'source' : this,
							'fileList':fileList,
							'uploader':uploader
					};
		 		   self.callEvent("onUploadCompleted", [eventData]);
			    }
				var file = $(response).find("file");
				var kind = $(file).attr("mediatype");
				var cacheName = $(file).attr("file-name");
				var size = $(file).attr("fileSize");
				self.upload(docName, kind, size, cacheName);
			};
			//ie 下面 "btn_edit_"+this._id会遮住this._id + "_uploaderDiv所以对_uploaderDiv绑定出发不到mouseout事件
			//'uploaderDiv':justep.Browser.IE?"btn_edit_"+this._id:this._id + "_uploaderDiv",
			var uploadParam = {
				'uploaderDiv':justep.Browser.IE?"btn_edit_"+this._id:this._id + "_uploaderDiv",
				'docPath':this.subPath?this.rootPath+"/"+this.subPath :this.rootPath,
				'clickCallBack':ClickCallback,
				'submitCallBack':selectedCallback,
				'completeCallBack':completedCallback,
				'caller':this,
				'filter':filter
			};
			this.uploader = justep.doc.InnerUtils.getHtml4Uploader(uploadParam);
		}
	}
};

justep.attachmentImage2.prototype.initLightBox = function(){
	var self =this;
	if (justep.Browser.isInApp) {
		var showInApp = function(event){
			if (justep.Browser.isInApp) {
				var justepApp = justep.getJustepApp();
				var getBrowserUrl = function() {
					var url = justepApp.utils.getFullUrl($('#' + self.imgID).attr('src'));
					return url;
				};
				var getDocName = function() {
					return new justep.Message(justep.Message.JUSTEP232507).getMessage();
				};
				justepApp.attachment.browserAttachment(getBrowserUrl,getDocName);
			}
		};
		$('#'+self.imgID).bind('click',function() {
			if(this.src.indexOf(justep.Request.convertURL('/UI/system/images/doc/empty.gif', true))==-1){
				showInApp();
			}
			return false;
		});
	}else{
		var OnOpenCallback = function(event){
			var lightBoxPicId=this.id+'Pic';
			var title="";
			var attImageId=this.id.replace('LightBox','');
			var attImageObj = justep.xbl(attImageId);
			
			if(attImageObj.data.length >0){
				title = attImageObj.data[0].docName;
			}
			this.setTitle(title);
			var src=$('#'+attImageId+'_image').attr('src');
			var image = new Image();
			var xblDialog = this;
			image.onload = function(){
				// image  has been loaded
				xblDialog.dlg.setDimension(image.width + 4, image.height + 23);
			    var b = document.body;
		    	if(typeof xblDialog.dlg.w == "string"){
		    	}else{
		    		xblDialog.dlg.x = b.scrollLeft+ (b.offsetWidth-xblDialog.dlg.w  -22)/2;
		    	}
		    	if(typeof xblDialog.dlg.h=="string"){
		    	}else{
		    		xblDialog.dlg.y =  b.scrollTop+ (b.offsetHeight - xblDialog.dlg.h - 4)/2;
		    	}
		    	if(xblDialog.dlg.y<0)xblDialog.dlg.y=0;
		    	if(xblDialog.dlg.x<0)xblDialog.dlg.x=0;
		    	xblDialog.dlg.style.left=xblDialog.dlg.x;
		    	xblDialog.dlg.style.top=xblDialog.dlg.y;
		    	xblDialog.setContentHTML('<img id='+lightBoxPicId+' src="'+src+'" width="100%" height="100%"></img>');
			};
			image.src=src;
		};
		var lightBoxId=this._id+'LightBox';
		this.lightBox=new justep.Dialog(lightBoxId,'','true','',0,0,0,0,null,OnOpenCallback,null);
		$('#'+this.imgID).bind('dblclick',function() {
			if(this.src.indexOf(justep.Request.convertURL('/UI/system/images/doc/empty.gif', true))==-1){
				justep.xbl(this.getAttribute('attachId')).lightBox.open();
			}
			return false;
		});
	}
	
}

justep.attachmentImage2.prototype.upload = function(docName, kind, size, cacheName, revisionCacheName, commentFileContent){
	var docID = (new justep.UUID()).valueOf();
	/*重新上传,清空data和changeLog的数据*/
	this.data = [];
	this.changeLog = {items:[],"operate":"","url":""};
	
	if(!this.docPath){
		this.getDocPath();
	}
	
	justep.doc.InnerUtils.addChangeLog(this.changeLog, "new", [docID, "0", "", "", docName, kind, size, this.parentID, this.docPath, this.docDisplayPath, "", "", "", "", ""], ["attachment",cacheName, !revisionCacheName?"" :revisionCacheName, !commentFileContent?"":commentFileContent]);
	var doc = {
		docID : docID,
		docName : docName,
		size : size,
		fileID : "",
		docPath : this.docPath,
		time : justep.Date.toString(new Date(), justep.Date.STANDART_FORMAT)
	};
	this.data.push(doc);
	this.commit();
};

justep.attachmentImage2.prototype.commit = function(){
	var items = justep.doc.InnerUtils.commitDoc(this.changeLog,this.rootPath,"commitAttachAction").rows;
	var doc = null;
	var oldValue = this.context;
	this.context=false;
	try{
		for(var i=0; i<items.length; i++){
			var item = items[i];
			if((item.userdata.recordState == 'new' || item.userdata.recordState =='edit') && item.sKind.value != 'dir'){
				var docID = item.userdata.id.value;
				for (var j = 0; j < this.data.length; j++) {
					if (docID == this.data[j].docID) {
						doc = this.data[j];
					}
				}
				doc.fileID = item.sFileID.value;
				var docLiveVersionID = item.sDocLiveVersionID.value;
				justep.doc.InnerUtils.updateChangeLog(this.changeLog,docID,doc.fileID,docLiveVersionID);				
				this.setValue(this.data);
			}
		}
	}	
	catch(e){
	   throw e;
	}finally{
	  this.context= oldValue;
	}
	this.ownerChanged();
};


justep.attachmentImage2.prototype.deleteattachmentImage = function(){
	var old = this.context;
	this.context = false;
	try{
		var value = justep.xbl(this.ownerData).getValue(this.relation);
		this.oldRelationData = value;
		justep.xbl(this.ownerData).setValue(this.relation, "" );
	    var img = $("#"+this.imgID);
	    img.attr("src",justep.Request.convertURL('/UI/system/images/doc/empty.gif', true));
	}catch(e){
		throw e;
	}finally{
       this.context = old;
	}
};

justep.attachmentImage2.prototype.save = function(){
	if(!this.isChange()){
		return;
	}
	justep.doc.InnerUtils.saveDoc(this.changeLog);

    this.changeLog = {items:[],"operate":"","url":""};
};

justep.attachmentImage2.prototype.getDocPath = function(){
	var parentID;
	if(!this.subPath){
		this.docPath = this.rootPath;
		parentID = this.docPath.substring(this.docPath.lastIndexOf("/")+1);
		var row = justep.doc.InnerUtils.queryDoc(parentID, undefined, ["sDocDisplayPath", "sDocName"],undefined,undefined,"single");
		var parentDocDisplayPath = row.sDocDisplayPath.value;
		var parentDocName = row.sDocName.value;
		this.docDisplayPath = justep.doc.InnerUtils.getDocFullDisplayPath(parentDocName, parentDocDisplayPath);
		
	}else{	
		var options = {};
		/*var param = justep.Doc2.createParam("queryLinkedDir", ["root-path", "sub-path", "bill-id", "process", "activity", "isJson"], [this.rootPath, this.subPath, "aaaaaaa", "aaaaaaaaa", "aaaaaaaa", "true"]);//暂时调用queryLinkedDir.xpl参数用"aaaaaaa"占位
		var sendParam = new justep.Request.ActionParam();
		sendParam.setXml('param',new justep.Request.XMLParam(param));	
		options.process = "/SA/doc/system/systemProcess";
		options.activity = "mainActivity";
		
		options.dataType = "json";
		options.parameters = sendParam;
		options.action = "dispatchOptRDFAction";
		options.directExecute = true;
		options.callback = function(data) {
		};
		var response = justep.Request.sendBizRequest2(options);
		if(!justep.Request.isBizSuccess(response,'json')){
			throw new Error("获取docDisplayPath失败");
	    }*/
		/*var rows = justep.Request.responseParseJSON(response).data.value.rows;*/
		var sendParam = new justep.Request.ActionParam();
		sendParam.setString("rootPath", this.rootPath);
		sendParam.setString("subPath", this.subPath);
		sendParam.setString("billID", this.billID);
		sendParam.setString("process", this.process);
		sendParam.setString("activity", this.activity);
		sendParam.setBoolean("isTree", false);
		
		options.process = "/SA/doc/system/systemProcess";
		options.activity = "mainActivity";
		
		options.dataType = "json";
		options.parameters = sendParam;
		options.action = "queryLinkDirAction";
		options.directExecute = true;
		options.callback = function(data) {
		};
		//__checkMD5Code2__
		options.executeContext = ('undefined'!=typeof(__executeContext__))?__executeContext__:null;
		var response = justep.Request.sendBizRequest2(options);
		if(!justep.Request.isBizSuccess(response,'json')){
			throw justep.Error.create(new justep.Message(justep.Message.JUSTEP232060).getMessage());
	    }
		
		var rv = justep.Request.responseParseJSON(response).data.value;
		
		for (var i = 0; i < rv.rows.length; i++) {
			var row = rv.rows[i];
			if(row.is_exist.value == "true")
				continue;
			var version = "0"; 
			justep.doc.InnerUtils.addChangeLog(this.changeLog, "newDir", [row.userdata.id.value, version, "", "", row.sDocName.value, "dir", "", row.sParentID.value, row.sDocPath.value, row.sDocDisplayPath.value, "", "", "", "", ""], undefined ,"");
		}
		var userData = rv.userdata;
		parentID = userData["sys.selectedID"];
		this.docPath =  userData["sys.selectedPath"];
		this.docDisplayPath = userData["sys.selectedDisplayPath"];
	}
	this.parentID = parentID;
};

justep.attachmentImage2.prototype.isChange = function(){
	return (!!this.changeLog.items && this.changeLog.items.length>0);
};

justep.attachmentImage2.prototype.setAutoLoad = function(flag) {
	this.autoLoad = flag;
	this.context = flag;  //为true会刷新数据
	if(flag){
		if(this.isLogined) return;
		this.init();
		var data = justep.xbl(this.ownerData);
		if(data.getCount()>0) this.ownerChanged();      
		this.attachStoreEvent();
		this.isLogined = true ;
	}	
};

justep.attachmentImage2.prototype.refresh = function() {
	this.setAutoLoad(true);
};

justep.attachmentImage2.prototype.attachStoreEvent = function(){
   var data = justep.xbl(this.ownerData);
	if(data){
		var recallback = function(event){
			var self = this;
			if (!self.context) return;
			window.setTimeout(function(){
				self.ownerChanged();},200);
		};
		
		data.attachEvent(justep.XData.EVENT_REFRESHPAGEDATA_AFTER, recallback, this);
		data.attachEvent(justep.XData.EVENT_REFRESHDATA_AFTER, recallback, this);
		data.attachEvent(justep.XData.EVENT_INDEX_CHANGED, recallback, this);
		data.attachEvent(justep.XData.EVENT_DATA_CHANGED, recallback, this);
		
		data.attachEvent(justep.XData.EVENT_SAVEDATA_BEFORE, this.save , this);				
		var saveAfterCallback = function(event){
			var self = this;
			this.changeLog = {items:[],"operate":"","url":""};	
		};
		data.attachEvent(justep.XData.EVENT_SAVEDATA_AFTER, saveAfterCallback , this);		
	}
	
	var img = $('#'+this.imgID);
	img.bind("mouseout", 
		function(event){
			justep.xbl($(this).attr('attachid')).domouseout(event);
		}
	); 
	
};

justep.attachmentImage2.prototype.domouseover = function(self){
	if(this.ctrl){
		if (!this.disabled) {
			this.ctrl.style.top = $(self).height()-30 + "px";
			this.ctrl.style.left = $(self).width()-52 + "px";
			this.top = this.ctrl.style.top;
			this.left = this.ctrl.style.left;
			this.editButton.style.display='block';
			this.deleteButton.style.display='block';
		}else{
			this.ctrl.style.display = 'none';
		}
		    
	}
};
	
justep.attachmentImage2.prototype.domouseout = function(event){
		if(this.ctrl){
			var target = event.relatedTarget;
			if(target!=null){
				var related = target.id;
			}else{
				var related = null;
			}
			
			if(related != this._id+'_image' && related !="btn_edit_"+this._id &&  related!=this._id+"_uploaderDiv" && related != "btn_del_"+this._id && related !=this._id+"_editButImg" && related !=this._id+"_editButImg" && related !=this._id+"_delButImg" && (null!=related?related.indexOf('yuigen')==-1:true)){
				this.editButton.style.display = 'none';
				this.deleteButton.style.display = 'none';
			}
		}		
};
	
justep.attachmentImage2.prototype.refreshButton = function(){
		if(this.editButton){
			this.editButton.innerHTML = this.generateButton(this.getEditButtonImgUrl(true), this.getEditButtonImgUrl(false), true, new justep.Message(justep.Message.JUSTEP232508).getMessage(), ' onclick=""',this._id+"_editButImg");
		}
		if(this.deleteButton){
			this.deleteButton.innerHTML = this.generateButton(this.getDeleteButtonImgUrl(true), this.getDeleteButtonImgUrl(false), true, new justep.Message(justep.Message.JUSTEP232509).getMessage(), ' onclick="if(!(this.disabled)) justep.XBLObject.getXBLObject(this).onDeleteAttachmentImage();"',this._id+"_delButImg");
		}
};

justep.attachmentImage2.prototype.generateButton = function(src, disSrc, enable, alt, attrs,id){
	/*var s = "<span alt=\"" + alt + "\" style=\"height:20; width:16px; border:1px solid #ffffff\" " + attrs + " onmouseover=\"this.style.border='1px ridge'\" onmouseout=\"this.style.border='1px solid #ffffff'\" ";
	if(!enable) s +=" disabled=\"true\" ";
	s += "><img src=\"" + justep.Request.BASE_URL + "/" + (enable?src:disSrc) + "\" alt=\"" + alt + "\" ";
	//if(!enable) s += " style=\"filter:progid:DXImageTransform.Microsoft.BasicImage(grayscale=1)\"";
	s += "/></span>";*/
	var s = "<img id=\""+id+"\" src=\"" + justep.Request.BASE_URL+"/"
	+ (enable?src : disSrc) + "\" alt=\""
			+ alt
			+ "\" style=\"border:1px solid #ffffff\" "
			+ attrs
			+ " onmouseover=\"this.style.border='1px ridge'\" onmouseout=\"this.style.border='1px solid #ffffff'\" ";
	if (!enable)
		s += " disabled=\"true\" ";
	s += "/></img>";
	return s;
};

justep.attachmentImage2.prototype.getDeleteButtonImgUrl = function(enable){
	var s = justep.xbl(this.domNode[enable?'delete-image':'undelete-image']);
	return s=(enable?'UI/system/components/attachmentImage2/delete.gif':'/UI/system/components/blob/unremove.gif');
};
	
justep.attachmentImage2.prototype.getEditButtonImgUrl = function(enable){
	var s = justep.xbl(this.domNode[enable?'edit-image':'unedit-image']);
	return s?s:(enable?'UI/system/components/attachmentImage2/upload.gif':'/UI/system/components/blob/unedit.gif');
};
	
justep.attachmentImage2.prototype.onDeleteAttachmentImage = function(){
	if (this.checkEvent("onDeleteClick")){
		var eventData = {
				'cancel' : false,
				'source' : this
			};
 		this.callEvent("onDeleteClick", [eventData]);
 		if (eventData.cancel)
			return;
	}
	var ok = confirm(new justep.Message(justep.Message.JUSTEP232510).getMessage());
	if(ok) this.deleteattachmentImage();
};

justep.attachmentImage2.prototype.setDisabled = function(disabled){
    this.disabled = disabled;
};

justep.attachmentImage2.prototype.getDisabled = function(){
	return this.disabled;
};

justep.attachmentImage2.prototype.transformExtensionFilter = function(extensionFilter){
	if(this.runtime == "flash"){
		var filter = [];
		extensionFilter = extensionFilter.split(",");
		for(var i=0; i < extensionFilter.length; i++){
			var item = extensionFilter[i].split("|");
			filter.push({description:jQuery.trim(item[0]), extensions:jQuery.trim(item[1])});
		}
		return filter;
	}else if(this.runtime == "html4"){
		var filter = new Array();
		extensionFilter = extensionFilter.split(",");
		for(var i=0; i < extensionFilter.length; i++){
			var item = extensionFilter[i].split("|");
			var miniType = jQuery.trim(item[1]).replace(new RegExp('\\*\\.','gm'),'');
			miniType = miniType.replace(new RegExp(';','gm'),'|');
			filter.push(miniType);
		}
		return filter.join('|');
	}
};

justep.attachmentImage2.prototype.setExtensionFilter = function(extensionFilter){
	this.extensionFilter = extensionFilter;
	this.initUploader();
};

justep.attachmentImage2.prototype.addEvents = function(){
    this.__onCreate = this.domNode.getAttribute("onCreate")? justep.Function.get(this.domNode.getAttribute("onCreate")):null;
	if(this.__onCreate && typeof this.__onCreate =="function"){
		this.attachEvent("onCreate", this.__onCreate, this);
	}
	this.__onEditClick = this.domNode.getAttribute("onEditClick")? justep.Function.get(this.domNode.getAttribute("onEditClick")):null;
	if(this.__onEditClick && typeof this.__onEditClick =="function"){
		this.attachEvent("onEditClick", this.__onEditClick, this);
	}
	this.__onDeleteClick = this.domNode.getAttribute("onDeleteClick")? justep.Function.get(this.domNode.getAttribute("onDeleteClick")):null;
	if(this.__onDeleteClick && typeof this.__onDeleteClick =="function"){
		this.attachEvent("onDeleteClick", this.__onDeleteClick, this);
	}
	this.__onFileSelected = this.domNode.getAttribute("onFileSelected")? justep.Function.get(this.domNode.getAttribute("onFileSelected")):null;
	if(this.__onFileSelected && typeof this.__onFileSelected =="function"){
		this.attachEvent("onFileSelected", this.__onFileSelected, this);
	}
	this.__onUploadCompleted = this.domNode.getAttribute("onUploadCompleted")? justep.Function.get(this.domNode.getAttribute("onUploadCompleted")):null;
	if(this.__onUploadCompleted && typeof this.__onUploadCompleted =="function"){
		this.attachEvent("onUploadCompleted", this.__onUploadCompleted, this);
	}
	
	if (this.checkEvent("onCreate")){
 		this.callEvent("onCreate", [{'source' : this}]);
	}
};