justep.NumberList = function(parent, className, input, min, max, minlengh, size, callback) {
	var list = this;
	this.element = $("body").append("<ul/>").children().last().addClass(className).get(0);
	this.move = 0;
	this.input = input;
	if(justep.Browser.hasTouch)this.input.readOnly=true;
	this.min = min;
	this.max = max;
	this.minlength = minlengh || 1;
	$(input).bind("keypress",function(event){
		list.hide();
		if(event.keyCode<48 || event.keyCode>57){
			event.returnValue=false;
			return;
		}
	}).bind("paste",function(event){
		event.returnValue=false;
	}).bind("click", function(event) {
		list.show();input.select();
	}).bind("change", function(event) {
		var v = parseInt($(input).val());
		if(v<list.min)$(input).val(list.min);
		if(v>list.max)$(input).val(list.max);
	});
	
	this.setParam(min, max, minlengh, size, callback);
};

justep.NumberList.prototype.setParam = function(min, max, minlengh, size, callback){
	$(this.element).empty();
	var list = this;
	this.min = min;
	this.max = max;
	size = size || 7;
	this.canShowAll = this.max-this.min+1 <= size;
	if(!this.canShowAll){
		this.createChild("-", function() {
				list.isFocus=true;
				list.start(-1);
			}, function() {
				list.isFocus=false;
				list.stop();
				$(list.input).focus();
			});
	}
	this.showItem = size;
	if(this.canShowAll) this.showItem = this.max-this.min+1; 
	for (var i = 0; i < this.showItem; i++) {
		this.createChild(" ", function(evt) {list.isFocus=true;
				}, function(evt){
					var value = $(justep.Event.getTarget(evt)).text();
					var $input = $(list.input).val(value);
					if(!list.input.readOnly) $input.focus();
					list.isFocus=false;
					list.hide();
					$(list.input).change();
					if(callback) callback(value);
				});
	}
	if(!this.canShowAll){
	this.createChild("+", function() {
				list.isFocus=true;
				list.start(1);
			}, function() {
				list.isFocus=false;
				list.stop();
				$(list.input).focus();
			});
	}
	this.hide();
};

justep.NumberList.current = null;

justep.NumberList.initHover = function(element){
	$(element).hover(function(event){$(event.srcElement||event.target).addClass("hover");},
					 function(event){$(event.srcElement||event.target).removeClass("hover");});
};

justep.NumberList.prototype.hideEvent = function(event){
	var target=event.target||event.srcElement;
	var self = justep.NumberList.activeObj;
    if(self && target.parentElement!=self.element) 
    	self.hide();
}

justep.NumberList.prototype.show = function() {
	var input = this.input;
	this.current = parseInt(input.value||this.min);
	this.refresh();
	var p = $(input);
	var e = $(this.element);
	e.css({top:-3000,left:-3000}).show();
	var pos = p.offset();
	var lup_top = pos.top-e.outerHeight(true);
	var lup = $(document).height()<pos.top+p.outerHeight(true)+e.outerHeight(true) && lup_top>0;
	e.css({top:(lup?(pos.top-e.outerHeight(true)):(pos.top+p.outerHeight(true))),left:pos.left});
	justep.NumberList.activeObj = this;
	$("body").bind("mousedown touchstart", this.hideEvent);
};

justep.NumberList.prototype.hide = function() {
	$("body").unbind("mousedown touchstart", this.hideEvent);
	justep.NumberList.activeObj = null;
	$(this.element).hide();
};

justep.NumberList.prototype.createChild = function(content, handler, handler2) {
	var child = $(this.element).append("<li/>").children().last().get(0);
	$(child).text(content);
	justep.NumberList.initHover(child);

	if (handler2) {
		$(child).bind("mousedown", handler);
		$(child).bind("mouseup", handler2);
	} else {
		$(child).bind("click", handler);
	}
};

justep.NumberList.prototype.refresh = function() {
	var childs = $(this.element).children();

	if(this.canShowAll){
		var top = this.min;
		for (var i = 0; i <= this.max-this.min; i++) {
			$(childs.get(i)).removeClass("hover");
			var str = (top++) + "";
			for (; str.length < this.minlength; str = '0' + str) {
			}
			$(childs.get(i)).text(str);
			if(top==this.current && i>3){
				var self = this;
				var c = $(childs.get(i));
				var j = i;
			    window.setTimeout(function(){
					self.element.scrollTop = c.outerHeight()*(j-3);
				},10);
			}
		}
	}else{
		var half = parseInt(this.showItem / 2);
		var cur = this.current;
		if (cur >= this.max - half) {
			cur = this.max - half;
		} else if (cur <= this.min + half) {
			cur = this.min + half;
		}

		var top = cur - half - 1;

		for (var i = 1; i < this.showItem + 1; i++) {
			$(childs.get(i)).removeClass("hover");
			var str = (top + i) + "";			
			for (; str.length < this.minlength; str = '0' + str) {
			}
			$(childs.get(i)).text(str);
		}
	}
};

justep.NumberList.prototype.start = function(value) {
	this.move = value;
	justep.NumberList.current = this;
	this.run();
};

justep.NumberList.prototype.stop = function() {
	this.move = 0;
};

justep.NumberList.prototype.run = function() {
	if ((this.move > 0 && this.current + 3 < this.max)
			|| (this.move < 0 && this.current - 3 > this.min)) {
		this.current += this.move;
		this.refresh();
		setTimeout("justep.NumberList.current.run()", 60);
	}
};

justep.Calendar = function(){
	var body = document.getElementsByTagName("body")[0];
	
	this.element = $("table[name='_calendar_']").size()<=0?$(body).append(justep.Calendar.HTML()).children().last().get(0):$("table[name='_calendar_']").get(0);
	this.modalCover = $("div[name='_modal_cover_']").size()<=0?$(body).append("<div name='_modal_cover_' class='modalCover'/>").children().last().get(0):$("div[name='_modal_cover_']").get(0);

	$(body).bind("mousedown touchstart", function(evt){
		var c = justep.Calendar.get();
		var d = c.element;
		if (d.style.display != "none") {
			var t = evt.srcElement||evt.target;
			if(t.parentElement==c.monthList.element
					||t.parentElement==c.yearList.element
					||t.parentElement==c.hourList.element
					||t.parentElement==c.minList.element	
					||t.parentElement==c.secList.element) return;
			for (; t && t != d; t = t.parentNode) {
			}
			if (!t) {
				justep.Calendar.get().hide();
			}
		}
	});
	
	var enterHandler = function() {
		var cal = justep.Calendar.get();
	
		var year = cal.inputYear.value;
		var month = cal.inputMonth.value - 1;
		var day = cal.day;
		if(year<1900)year=1900;
		if(year>2099)year=2099;
		if(month<0)month=0;
		if(month>11)month=11;

		var date = new Date();
		date.setDate(1);
		date.setYear(year);
		date.setMonth(month);
		date.setDate(day);
		if(cal.input.focus)cal.input.focus();

		if (cal.isTimestamp) {
			var hour = cal.inputHour.value;
			var min = cal.inputMin.value;
			var sec = cal.inputSec.value;
			if(hour>23)hour=23;
			if(min>59)min=59;
			if(sec>59)sec=59;
			
			date.setMinutes(min);
			date.setHours(hour);
			date.setSeconds(sec);
			if(cal.input._setValue)cal.input._setValue(justep.Date.toString(date, justep.Date.STANDART_FORMAT)); else if(cal.input.setValue)cal.input.setValue(justep.Date.toString(date, justep.Date.STANDART_FORMAT)); else $(cal.input).val(justep.Date.toString(date, justep.Date.STANDART_FORMAT));		
		} else {
			if(cal.input._setValue)cal.input._setValue(justep.Date.toString(date, justep.Date.STANDART_FORMAT_SHOT)); else if(cal.input.setValue)cal.input.setValue(justep.Date.toString(date, justep.Date.STANDART_FORMAT_SHOT)); else $(cal.input).val(justep.Date.toString(date, justep.Date.STANDART_FORMAT_SHOT));
		}
		if(cal.input.blur)cal.input.blur();
		
		justep.Calendar.hide();
	};
	
	
	$(this.element).find("button[name='_calendar_prev_year_']").bind("click", function() {
		justep.Calendar.get().gotoYear(-1);
	});
	
	$(this.element).find("button[name='_calendar_prev_month_']").bind("click", function() {
		justep.Calendar.get().gotoMonth(-1);
	});
	
	this.inputYear = $(this.element).find("input[name='_calendar_year_']").bind("keyup",function(event){
		justep.Calendar.get().refresh(); 
		if(event.keyCode==13){
			enterHandler();
		}
	}).bind("change", function(event) {
		justep.Calendar.get().refresh();
	}).get(0);
	
	this.inputMonth = $(this.element).find("input[name='_calendar_month_']").bind("change", function(event) { 
		justep.Calendar.get().refresh();
	}).bind("keyup",function(event){
		justep.Calendar.get().refresh();
		if(event.keyCode==13){
			enterHandler();
		}
	}).get(0);	
	
	$(this.element).find("button[name='_calendar_next_year_']").bind("click", function() {
		justep.Calendar.get().gotoYear(1);
	});

	$(this.element).find("button[name='_calendar_next_month_']").bind("click", function() {
		justep.Calendar.get().gotoMonth(1);
	});

	var handler = function(event) {
		var value = $(justep.Event.getTarget(event)).text();
		var cal = justep.Calendar.get();		
		if (value != "") {
			cal.day = value;
			//cal.refresh();
			/* lzg 暂时保留目前逻辑一致都是点击确定返回
			 */
			if(cal.type != justep.Calendar.ONLY_DATE) cal.refresh(); 
			else {
				var year = cal.inputYear.value;
				var month = cal.inputMonth.value-1;
				var day = cal.day;
				
				var date = new Date();
				date.setDate(1);
				date.setYear(year);
				date.setMonth(month);
				date.setDate(day);
				if(cal.input.focus)cal.input.focus();
				if (cal.isTimestamp) {
					date.setSeconds(cal.inputSec.value);
					date.setMinutes(cal.inputMin.value);
					date.setHours(cal.inputHour.value);
					if(cal.input._setValue)cal.input._setValue(justep.Date.toString(date, justep.Date.STANDART_FORMAT)); else if(cal.input.setValue)cal.input.setValue(justep.Date.toString(date, justep.Date.STANDART_FORMAT)); else $(cal.input).val(justep.Date.toString(date, justep.Date.STANDART_FORMAT));
				} else {
					if(cal.input._setValue)cal.input._setValue(justep.Date.toString(date, justep.Date.STANDART_FORMAT_SHOT)); else if(cal.input.setValue)cal.input.setValue(justep.Date.toString(date, justep.Date.STANDART_FORMAT_SHOT)); else $(cal.input).val(justep.Date.toString(date, justep.Date.STANDART_FORMAT_SHOT));
				}
				if(cal.input.blur)cal.input.blur();
				justep.Calendar.hide();
			}
		}
	};

	$(this.element).find(".day").each(function(){$(this).bind("click", handler);});
	
	this.inputHour = $(this.element).find("input[name='_calendar_hour_']").bind("keyup",function(event){
		if(event.keyCode==13){
			enterHandler();
		}
	}).get(0);
	
	this.inputMin = $(this.element).find("input[name='_calendar_min_']").bind("keyup",function(event){
		if(event.keyCode==13){
			enterHandler();
		}
	}).get(0);

	this.inputSec = $(this.element).find("input[name='_calendar_sec_']").bind("keyup",function(event){
		if(event.keyCode==13){
			enterHandler();
		}
	}).get(0);
	
	$(this.element).find("button[name='_calendar_ok_']").bind("click", function() {
		enterHandler();
	});
	
	$(this.element).find("button[name='_calendar_cancel_']").bind("click", function() {
		justep.Calendar.hide();
	});
	
	$(this.element).find("button[name='_calendar_clear_']").bind("click", function() {
		var cal = justep.Calendar.get();
		if(cal.input._setValue)cal.input._setValue(""); else if(cal.input.setValue)cal.input.setValue(""); else $(cal.input).val("");
		justep.Calendar.hide(); 
	});
	var className = justep.Browser.hasTouch?"calendarList touchCalendarList":"calendarList";
	this.monthList = new justep.NumberList($(this.inputYear).parent().get(0), className, this.inputMonth, 1, 12,1,12);
	this.yearList = new justep.NumberList($(this.inputYear).parent().get(0), className, this.inputYear, 1900, 2099,1,justep.Browser.hasTouch?200:null);
	this.hourList = new justep.NumberList($(this.inputYear).parent().get(0), className, this.inputHour, 0, 23,2,justep.Browser.hasTouch?24:null);
	this.minList = new justep.NumberList($(this.inputYear).parent().get(0), className, this.inputMin, 0, 59,2,justep.Browser.hasTouch?60:null);	
	this.secList = new justep.NumberList($(this.inputYear).parent().get(0), className, this.inputSec, 0, 59,2,justep.Browser.hasTouch?60:null);	
	this.hide();
};

justep.Calendar.HTML = function(){ return '<table name="_calendar_" class="calendar '+(justep.Browser.hasTouch?'touch':'')+'" cellpadding="0" cellspacing="0">'
					+'<thead><tr valign="middle"><td class="title" colspan="7" align="center"><button name="_calendar_prev_year_" class="prev-year"/><button name="_calendar_prev_month_" class="prev-month"/><input name="_calendar_year_" class=" calendar-input calendar-year" maxlength="4" /><input class=" calendar-input calendar-" readonly="" value="-" /><input name="_calendar_month_" class=" calendar-input calendar-month" maxlength="2" /><button name="_calendar_next_month_" class="next-month"/><button name="_calendar_next_year_" class="next-year"/></td></tr><tr class="names"><td class="name">'+xforms.I8N.get('calendar.day6')+'</td><td class="name">'+xforms.I8N.get('calendar.day0')+'</td><td class="name">'+xforms.I8N.get('calendar.day1')+'</td><td class="name">'+xforms.I8N.get('calendar.day2')+'</td><td class="name">'+xforms.I8N.get('calendar.day3')+'</td><td class="name">'+xforms.I8N.get('calendar.day4')+'</td><td class="name">'+xforms.I8N.get('calendar.day5')+'</td></tr></thead>'
					+'<tbody><tr><td class="day weekend"></td><td class="day"></td><td class="day"></td><td class="day"></td><td class="day"></td><td class="day"></td><td class="day weekend">1</td></tr><tr><td class="day weekend">2</td><td class="day">3</td><td class="day">4</td><td class="day">5</td><td class="day">6</td><td class="day">7</td><td class="day weekend">8</td></tr><tr><td class="day weekend">9</td><td class="day">10</td><td class="day selected">11</td><td class="day">12</td><td class="day">13</td><td class="day">14</td><td class="day weekend">15</td></tr><tr><td class="day weekend">16</td><td class="day">17</td><td class="day today">18</td><td class="day">19</td><td class="day">20</td><td class="day">21</td><td class="day weekend">22</td></tr><tr><td class="day weekend">23</td><td class="day">24</td><td class="day">25</td><td class="day">26</td><td class="day">27</td><td class="day">28</td><td class="day weekend">29</td></tr><tr><td class="day weekend   ">30</td><td class="day">31</td><td class="day"></td><td class="day"></td><td class="day"></td><td class="day"></td><td class="day weekend"></td></tr></tbody>'
					+'<tfoot><tr><td colspan="7"><input name="_calendar_hour_" maxlength="2" class=" calendar-input"/>:<input name="_calendar_min_" class=" calendar-input" maxlength="2"/>:<input name="_calendar_sec_" class=" calendar-input" maxlength="2"/></td></tr><tr><td colspan="7"><button name="_calendar_ok_" class=" calendar-button">'+xforms.I8N.get('calendar.ok')+'</button><button name="_calendar_cancel_" class=" calendar-button">'+xforms.I8N.get('calendar.cancel')+'</button><button name="_calendar_clear_" class=" calendar-button">'+xforms.I8N.get('calendar.clear')+'</button></td></tr></tfoot>'
					+'</table>'};

justep.Calendar.get = function(){
	if(!justep.Calendar.instance){
		justep.Calendar.instance = new justep.Calendar();
	}
	return justep.Calendar.instance; 
};

justep.Calendar.daysOfMoth = [31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31];

justep.Calendar.ONLY_DATE = 0;
justep.Calendar.HOURS = 1;
justep.Calendar.MINUTES = 2;
justep.Calendar.SECONDS = 3;

justep.Calendar.prototype.today = function() {
	this.refreshControls(new Date());
};

justep.Calendar.prototype.refreshControls = function(date) {
	this.day = date.getDate();
	this.inputMonth.value = date.getMonth()+1;
	this.inputYear.value = date.getYear() < 1000 ? 1900 + date.getYear() : date.getYear();

	if (this.isTimestamp) {
		this.inputHour.value = justep.String.zeros(date.getHours(), 2);
		this.inputMin.value = this.type >= justep.Calendar.MINUTES ? justep.String.zeros(date
						.getMinutes(), 2) : "00";
		this.inputSec.value = this.type >= justep.Calendar.SECONDS ? justep.String.zeros(date
						.getSeconds(), 2) : "00";
	}

	this.refresh();
};

justep.Calendar.show = function(input, type, readonly) {
	var cal = justep.Calendar.get();

	if (!type) {
		type = justep.Calendar.ONLY_DATE;
	}
	
	readonly = !!readonly;
	/*
	cal.inputYear.readOnly = readonly;
	cal.inputMonth.readOnly = readonly;
	cal.inputHour.readOnly = readonly;
	cal.inputMin.readOnly = readonly;
	cal.inputSec.readOnly = readonly;
	*/
	cal.yearList.element.onclick 
	= cal.monthList.element.onclick 
	= cal.hourList.element.onclick 
	= cal.minList.element.onclick 
	= cal.secList.element.onclick 
	= cal.element.onclick 
	= function(e){
		(e||event).cancelBubble = readonly;
	}

	cal.input = input;
	cal.type = type;
	cal.isTimestamp = type != justep.Calendar.ONLY_DATE;

	if(!cal.isTimestamp) $(cal.element).find("tfoot tr:first-child").hide();
	else $(cal.element).find("tfoot tr:first-child").show();
	var date;

	try {
		var v = input._getValue?input._getValue():(input.getValue?input.getValue():$(input).val());
		date = cal.isTimestamp ? justep.Date.fromString(v, 'yyyy-MM-ddThh:mm:ss') : justep.Date.fromString(v, justep.Date.STANDART_FORMAT_SHOT);
	} catch (e) {
		date = new Date();
	}
	if (date != null) {
		cal.refreshControls(date);
	} else {
		cal.today();
	}
	var p = $(input.element?input.element:input);
	var e = $(cal.element);
	e.css({top:-3000,left:-3000}).show();
	var pos = p.offset();
	var lup_top = pos.top-e.outerHeight(true);
	var lup = $(document).height()<pos.top+p.outerHeight(true)+e.outerHeight(true) && lup_top>0;
	
	var t = lup?lup_top:(pos.top+p.outerHeight(true));
	if(t<0) t=0;
	var l = p.offset().left;
	if(l<0) l=0;
	var docW = $(document).width(),calW = e.outerHeight(true);
	if(docW<l+calW) l = l-(l+calW-docW);
	if(l<0) l=0;
	e.css({top:t,left:l});
};

justep.Calendar.prototype.hide = function() {
	this.monthList.hide();
	this.yearList.hide();
	this.hourList.hide();
	this.minList.hide();	
	this.secList.hide();	
	$(this.element).hide();
	$(this.modalCover).hide();
};

justep.Calendar.hide = function() {
	justep.Calendar.get().hide();
};

justep.Calendar.prototype.getFirstDay = function() {
	var year = this.inputYear.value;
	var month = this.inputMonth.value-1;
	if(year<1900)year=1900;
	if(year>2099)year=2099;
	if(month<0)month=0;
	if(month>11)month=11;
	
	var date = new Date();
	date.setDate(1);
	date.setMonth(month);
	date.setYear(year);
	
	return date.getDay(); 
};

justep.Calendar.prototype.getDaysOfMonth = function() {
	var year = this.inputYear.value;
	var month = this.inputMonth.value-1;
	if(year<1900)year=1900;
	if(year>2099)year=2099;
	if(month<0)month=0;
	if(month>11)month=11;
	
	if (month == 1
			&& ((0 === (year % 4)) && ((0 !== (year % 100)) || (0 === (year % 400))))) {
		return 29;
	}

	return justep.Calendar.daysOfMoth[month];
};

justep.Calendar.prototype.refresh = function() {;
	var now = new Date();
	this.currentDay = now.getDate();
	this.currentMonth = now.getMonth();
	this.currentYear = now.getFullYear();
	var firstDay = this.getFirstDay();
	var daysOfMonth = this.getDaysOfMonth();
	var cont = 0;
	var i = 1;
	var currentMonthYear = this.inputMonth.value-1 == this.currentMonth
			&& this.inputYear.value == this.currentYear;
	var that = this;
	$(this.element).children("tbody").children().each(function(){
		var trLine = this;
		var b = false;
		for (var j = 0; j < 7; j++, cont++) {
			var cell = $(trLine.childNodes[j]);
			cell.removeClass("hover");
			if(currentMonthYear && i == that.currentDay) cell.addClass("today"); else cell.removeClass("today");
			if(j == 6 || j==0) cell.addClass("weekend"); else cell.removeClass("weekend");
			var d = "";
			if(cont >= firstDay && cont < firstDay + daysOfMonth) {b=true;d=i++;justep.NumberList.initHover(cell.get(0));} else cell.unbind("mouseout mouseover");
			cell.text(d+"");
			if(d == that.day && !isNaN(parseInt(d))) cell.addClass("selected"); else cell.removeClass("selected");
		}
		trLine.style.display=b?"":"none";
	}
	);
};

justep.Calendar.prototype.gotoYear = function(offset){
	var year = parseInt(this.inputYear.value)+offset;
	if(year<1900)year=1900;
	if(year>2099)year=2099;
	this.inputYear.value = year;
	this.refresh();
};

justep.Calendar.prototype.gotoMonth = function(offset){
	var month = parseInt(this.inputMonth.value)+offset;
	if(month<1 || month>12){
		var year = parseInt(this.inputYear.value)+offset;
		if(year>=1900){
			month=offset<0?12:1;
			this.inputYear.value =year;
		}else{
			month = offset<0?1:12;
		}
	}
	this.inputMonth.value = month; 
	this.refresh();
};